// ARBGEN.CPP - implementarea clasei Arbore_generalizat

#include "arbgen.hpp"
#include <alloc.h>
#include <string.h>
#include <conio.h>
#include <iostream.h>

void Arbore_generalizat::Creaza_radacina(const char *nume)
					   // creaza nodul radacina
{
  if(Root)
    cout<<"*** exista deja nod radacina ***";
  else
    Root=new Nod(nume);
}

char tipar[40]="";  // folosesc la tiparirea arborelui
char *tip1="",
     *tip2="",
     *tip;

void Arbore_generalizat::Print(PNod p)  // tiparire in inordine
{ 
  for(PNod r=p->Prim_fiu;r;r=r->Frate_drept)
      {
	cout<<tipar<<(tip=r->Frate_drept ? tip2 : tip1)<<r->Nume<<endl;
	if(r->Frate_drept)  // nu e ultimul fiu
	  strcat(tipar,"   ");
	else
	  strcat(tipar,"    ");
	Print(r);
	tipar[strlen(tipar)-4]='\0';
      }
}

void Arbore_generalizat::Print(void)
{
  PNod p;
  if(!Root)  // arbore vid
    return;
  cout<<Root->Nume<<endl;
  if(!Root->Prim_fiu)
    return;
  Print(Root);
}

PNod Arbore_generalizat::Pointer(const char * cheie_nod,PNod p)
{
  if(p){
    if(!strcmp(p->Nume,cheie_nod)) 
      return p;
    for(PNod r=p->Prim_fiu;r;r=r->Frate_drept)
      {
	if(!strcmp(r->Nume,cheie_nod)) 
	  return r;
	PNod r1=Pointer(cheie_nod,r);
	if (r1) return r1;
      }
    return NULL;
  }
}

PNod Arbore_generalizat::Pointer(const char * cheie_nod)
{ 
  return Pointer(cheie_nod,Root);
}

PNod Arbore_generalizat::Adauga_fiu(PNod p,const char *nume)
{
  PNod s=NULL;
  if(p){
    s=new Nod(nume,p);  // se creaza un nou nod
    if(!(p->Prim_fiu))  // primul fiu
       p->Prim_fiu=s;
    else {
      for(PNod r=p->Prim_fiu;r->Frate_drept;r=r->Frate_drept);
      r->Frate_drept=s;  // mai exista fii, noul fiu devine ultimul
    }
    }
  return s;
}

void Arbore_generalizat::Adauga_fiu(const char *nume_tata,const char *nume)
{
  PNod p=Pointer(nume_tata);
  if(p)  // exista nodul tata
    Adauga_fiu(p,nume);
}

void Arbore_generalizat::Initializare_arbore(PNod p)
{
  if(p){
    for(PNod r=p->Prim_fiu;r;r=r->Frate_drept)
      Initializare_arbore(r);
    delete p;
  }
}

void Arbore_generalizat::Initializare_arbore(void)
{
  Initializare_arbore(Root);
  Root=NULL;
}

// destructor - parcurgerea arborelui si eliberarea spatiului
Arbore_generalizat::~Arbore_generalizat()
{
  Initializare_arbore(Root);
}

