// ARBGEN.HPP - declaratiile claselor Nod si Arbore_generalizat

#include <alloc.h>
#include <string.h>

struct  Nod  
     {  char *Nume;
	Nod *Prim_fiu;
	Nod *Frate_drept;
	Nod *Tata;

	Nod(const char * nume,Nod * tata = NULL){  // valoarea implicita
						   // e pentru nodul radacina
	      Nume=new char[strlen(nume)+1];
	      strcpy(Nume,nume);
	      Prim_fiu=Frate_drept=NULL;
	      Tata=tata;}

	 ~Nod(void){  // in destructor, eliberarea spatiului ocupat de nod
	      delete Nume;
	 }

     };

typedef Nod *PNod;

class Arbore_generalizat
 { 
    private:

    // date
    PNod Root;  // radacina arborelui

   // operatori

				// urmatorii 3 operatori returneaza pointerii
   PNod PTata(PNod p)           // spre nodurile tata, prim fiu si frate drept
     { return p->Tata;};
   PNod PPrim_fiu(PNod p) 
     { return p->Prim_fiu;};
   PNod PFrate_drept(PNod p)
     { return p->Frate_drept;};

   PNod Adauga_fiu(PNod p,const char *nume);  // adauga un fiu cu cheia data
   PNod Pointer(const char * cheie_nod,PNod p);  // returneaza pointerul spre 
						 // nodul cu cheia data, e 
						 // apelata de functia urmatoare 
   PNod Pointer(const char * cheie_nod);  // returneaza pointerul spre
					  // nodul cu cheia data
   void Print(PNod p);  // tipareste un subarbore cu radacina data
   void Initializare_arbore(PNod p);
   char *Cheie(PNod p)  // returneaza cheia unui nod indicat
     {return p->Nume;};


   public:

   // constructor
   Arbore_generalizat()
     { Root=NULL; }

   // operatori

   void Creaza_radacina(const char *nume);  // creaza nodul radacina
   void Adauga_fiu(const char *nume_tata,const char *nume);
   void Print(void);  // tipareste arborele
   void Print(const char * cheie_nod);  // tipareste subarborele cu rad data
   void Initializare_arbore(void);

   // urmatorii operatori returneaza cheile nodurilor din aceeasi "familie"
   // cu nodul cu cheia data   */
   char * Tata(const char *nume){ return Cheie(PTata(Pointer(nume)));};
   char * Prim_fiu(const char *nume)
		  { return Cheie(PPrim_fiu(Pointer(nume)));};
   char * Frate_drept(const char *nume)
		  { return Cheie(PFrate_drept(Pointer(nume)));};


   // destructor
   public:
   ~Arbore_generalizat();
 };
